directions = {'N': (0, 1), 'S': (0, -1), 'W': (-1, 0), 'E': (1, 0), }
dot = {'N': 'y0', 'S': 'y1', 'W': 'x1', 'E': 'x0', }


def intersect_rect(rect1, rect2):
    upper_rect = min(rect1, rect2, key=lambda x: x['y1'])
    down_rect = max(rect1, rect2, key=lambda x: x['y0'])
    left_rect = max(rect1, rect2, key=lambda x: x['x0'])
    right_rect = min(rect1, rect2, key=lambda x: x['x1'])
    if upper_rect['y1'] <= down_rect['y0'] or left_rect['x0'] >= right_rect['x1']:
        return 0
    a = upper_rect['y1'] - down_rect['y0']
    b = right_rect['x1'] - left_rect['x0']
    return a * b


def sum_coord(rect, move):
    rect['x0'] += move[0]
    rect['x1'] += move[0]
    rect['y0'] += move[1]
    rect['y1'] += move[1]
    return rect


def rect_space(rect):
    a = rect['x1'] - rect['x0']
    b = rect['y1'] - rect['y0']
    return a * b


def main():
    k, n = map(int, input().split())

    rect1 = {'x0': 0, 'x1': k, 'y0': 0, 'y1': k}
    rects = [None] * n

    for i in range(n):
        d, ai = input().split()
        ai = int(ai)
        save_coord = rect1[dot[d]]

        move = directions[d][0] * ai, directions[d][1] * ai
        rect1 = sum_coord(rect1, move)
        rect2 = rect1.copy()
        rect2[dot[d]] = save_coord
        rects[i] = rect2
    s = 0
    for i in rects:
        s += rect_space(i)
    for i in range(len(rects)):
        for j in range(i + 1, len(rects)):
            s -= intersect_rect(rects[i], rects[j])
    print(s)


if __name__ == '__main__':
    main()
